use calendar
go
create procedure prDropDefaultConstraint 
	@cTable varchar(128),
	@cColumn varchar(128)
as
declare @iTableID int,
	@iColID	int,
	@cConstraint	varchar(128),
	@cSQL		varchar(128)

select @iTableID=id from sysobjects where type='U' and name=@cTable
select @iColID=colid from SysColumns where ID=@iTableID and Name=@cColumn
select @cConstraint=name from sysobjects where parent_obj=@iTableID and Info=@iColID and xtype='D'
select @cSQL='ALTER TABLE '+@cTable+' DROP CONSTRAINT '+@cConstraint
exec (@cSQL)
return
go
exec prDropDefaultConstraint 'calendar','default_approved'
exec prDropDefaultConstraint 'calendar','mnotify_add'
exec prDropDefaultConstraint 'calendar','published'
exec prDropDefaultConstraint 'calgroup','published'
exec prDropDefaultConstraint 'resourcetype','display_public'
exec prDropDefaultConstraint 'users','security_level'
go
drop procedure prDropDefaultConstraint
go