#!/bin/sh
#
#  The directory where your servlet container library files
# are.
#
#   set the path in the next line to your servlet's engines
#   lib directory.
#

SERVER_LIB_DIR=/usr/local/jakarta-tomcat-5.5.8/common/lib
JARDIR=../../AddlJars
#JARDIR=../lib
if [ ! -d $SERVER_LIB_DIR ]; then
   echo "Server LIB Dir ($SERVER_LIB_DIR) not found! Please edit the script and re-run it."
   exit 1
fi
if [ ! -d $JARDIR ]; then
   echo "Jar LIB Dir ($JARDIR) not found! Please edit the script and re-run it."
   exit 1
fi
JARLIST=`find $SERVER_LIB_DIR -type f -iname "*.jar"`
CPATH=""
for THISJAR in $JARLIST; do
   CPATH=$CPATH:$THISJAR
done

JARLIST=`find $JARDIR -type f -iname "*.jar"`
for THISJAR in $JARLIST; do
   CPATH=$CPATH:$THISJAR
done
export CLASSPATH=$CPATH:../classes
echo Using Classpath $CLASSPATH
#
#  The actual command to run.
#
java -cp $CLASSPATH com.mhsoftware.cdaily.support.db.Schema330 ../configuration.properties ../style.properties
