
function hideFieldset(setID) {
	require(['dojo/dom-attr'],function(domAttr){
		domAttr.set(setID+'message','value','');
		domAttr.remove('IDbtnShowAlarmRow','disabled');
	});
	setDDValue(document.getElementById(setID+'timeValue',"0"));
	document.getElementById(setID).style.display='none';
}

function showFieldSet() {
	var iAvailable=0,bShown=false;
	require(['dojo/query','dojo/dom-attr'],function(query,domAttr){
		var a=query('.AlarmRow');
		for (var i=0; i < a.length; i++){
			var fldset=a[i];
			if (fldset.style.display=='none'){
				if (bShown){ 
					iAvailable++;
				} else {
					bShown=true;
					fldset.style.display='block';
				}
			}
		}
		if (iAvailable===0){
			domAttr.set('IDbtnShowAlarmRow','disabled','');
		}
	});
}


function initRangeDropdown(ddID,value,startValue,increment,maxValue){
	var dd=document.getElementById(ddID);
	dd.options.length=0;
	var opt;
	opt=new Option("",0,value==0);
	dd.options[dd.options.length]=opt;
	do {
		dd.options[dd.options.length]=new Option(startValue,startValue,value==startValue,value==startValue);
		startValue+=increment;
	} while (startValue<maxValue);
}


function getDDValue(dd){
	for (var i=0; i < dd.options.length; i++) {
		if (dd.options[i].selected) {
			return dd.options[i].value;
		}
	}
	return null;
}
function setDDValue(dd,value){
	for (var i=0; i < dd.options.length; i++) {
		dd.options[i].selected=(dd.options[i].value==value);
	}
}

function initLinkedDropdown(parentID,selectFirst){
	if (typeof selectFirst==='undefined') {
		selectFirst=false;
	}
	require(['dojo/dom-attr'],function(domAttr){

		var ddThisIncrement=document.getElementById(parentID),
			sID=domAttr.get(ddThisIncrement.id,"data-linked-element"),
			dd=document.getElementById(sID),
			iValue=parseInt(domAttr.get(sID,"data-value"),10),
			iThisValue=parseInt(getDDValue(ddThisIncrement),10);

		if (iThisValue==86400) {
			initRangeDropdown(sID,selectFirst ? 1 : iValue,1,1,31);
		} else if (iThisValue==3600) {
			initRangeDropdown(sID,selectFirst ? 1 : iValue,1,1,25);
		} else if (iThisValue==60) {
			initRangeDropdown(sID,selectFirst ? 10 : iValue,10,5,95);
		}
	});
}

function initAllDropdowns() {
	require(["dojo/query"],function(query){
		var a=query(".AlarmIncrement");
		for (var i=0; i < a.length; i++) {
			console.log("initAllDropdowns() - Initializing ID: "+a[i].id);
			initLinkedDropdown(a[i].id);
		}
	});
}
