<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<%@ page contentType = "text/html; charset=UTF-8"%>
<%@ page import="java.util.*,com.mhsoftware.cdaily.support.*,java.io.*,com.MHSoftware.dates.SaneDate,com.mhsoftware.cdaily.business.*,com.mhsoftware.cdaily.support.*,com.mhsoftware.cdaily.servlet.*" %>
<%
/*
    This JSP page is a sample page that shows how you can create
    a completely customized display for a day, week, or event view.

    For a week view, set the DAYS_DISPLAY variable to 7. For a
    single day, set it to one day.

    If you only have a few events, you could set the DAYS_DISPLAY
    to something like 90, and SHOW_EMPTY_DAYS to false. The
    output would then be a list of events for the next 90 days.

*/
%>
<HTML>
<HEAD>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<%=CalServlet.getGeneratorMeta()%>

	<META name="author" content="http://www.mhsoftware.com/connectdaily.htm">
	<META name="copyright" content="Copyright 2002-2014, MH Software, Inc. All Rights Reserved">
	<LINK REL="stylesheet" HREF="<%=WebApp.getProperty("DefaultStyleSheet")%>" type="text/css">
	<TITLE>Calendar List View</TITLE>
	<STYLE>
	Table.ControlsTable {
	}
	Table.ItemListTable {
	}
	.DayHeading {
	font-size: 16pt;
	}
	A.ItemLink {
	}

	</STYLE>
</HEAD>
	<BODY>

		<%
        int DAYS_DISPLAY=30;    // Set this to 7 for a week view, 1 for a single day, 31 for a month
        boolean SHOW_EMPTY_DAYS=false;
		CalServlet cs=new CalServlet();
		// Get our Effective User
		//
		User oUser=cs.getUser(request,response,true);

		Locale lc=cs.getNegotiatedLocale(request);
		ResourceBundle rb=CalServlet.getResourceBundle(lc);

        SaneDate sd=new SaneDate(),sdNext,sdPrevious;

        calitem ci;
        String cCriteria, cTime;

        //
        //  Look to see if a date was passed as an argument.
        //
        if (request.getParameter("date")!=null) {
            sd=new SaneDate(Integer.parseInt(request.getParameter("date")));
        }
		sd.setLocale(lc);
        //
        //  Now, reset the date to the start of the period and figure out the
        //  next and previous dates.
        //
        switch (DAYS_DISPLAY) {
        case SaneDate.DAYS_WEEK:
            sd.resetToStartDow();
            sdPrevious=new SaneDate(sd.getJulianDate()-SaneDate.DAYS_WEEK);
            sdNext=new SaneDate(sd.getJulianDate()+SaneDate.DAYS_WEEK);
            break;
        case 30:
            sd.subtract(sd.getDay()-1);
            sdNext=new SaneDate(sd.getJulianDate());
            sdNext.goMonth(1);
            sdPrevious=new SaneDate(sd.getJulianDate());
            sdPrevious.goMonth(-1);
            break;
        default:
            sdNext=new SaneDate(sd.getJulianDate());
            sdNext.add(DAYS_DISPLAY);
            sdPrevious=new SaneDate(sd.getJulianDate());
            sdPrevious.subtract(DAYS_DISPLAY);
            break;
        }

        //
        // Call the helper method to get the item vector, and parse the options
        //
        Vector v=CalHelper.getItemVectorAndOptions(request,lc);
        //
        // Get an array of vectors, where each element in the array corresponds
        // to one day. The vectors contain the calendar items that occurr on the
        // specified day.
        //
        Vector[] avDays=CalHelper.getDayVector(sd,new SaneDate(sd.getJulianDate()+(DAYS_DISPLAY-1)),v,WebApp.getTimeZone().getID(),Locale.getDefault());
        //
        //  Get the criteria that was parsed out by getItemVectorAndOptions()
        //
        cCriteria = (String)request.getAttribute("Criteria");
        int iCalendarID=Integer.parseInt(cCriteria.substring(cCriteria.indexOf("=")+1));
        //
        // Set up a calendar item formatter. It does some handy things.
        //
		CalendarItemFormatter cif=(CalendarItemFormatter)request.getAttribute("Formatter");
        %>

	<script Language="Javascript" TYPE="text/javascript">
    function popItem(iItemID, iSpecificDate) {
       window.open("ViewItem.html?detail=0&style_sheet=style.css&integral=0&dtwhen="+iSpecificDate+"&cal_item_id="+iItemID,"ViewItemWin"+(new Date().getTime()),"scrollbars=yes,resizable=yes,status=no,location=no,menubar=no,toolbar=no,width=600,height=500");
    }
	</script>

	<TABLE Class="ControlsTable">
		<TR>
			<TD VALIGN="TOP">
				<A Title="<%=rb.getString("Previous")%>" HREF="uniview.jsp?<%=cCriteria%>&date=<%=sdPrevious.getJulianDate()%>">
				<IMG Border="0" SRC="<%=Icons.getIconName(Icons.PREVIOUS,Icons.NORMAL)%>" ALT="Previous"></A>
				<A Title="<%=rb.getString("Next")%>" HREF="uniview.jsp?<%=cCriteria%>&date=<%=sdNext.getJulianDate()%>">
				<IMG Border="0" SRC="<%=Icons.getIconName(Icons.NEXT,Icons.NORMAL)%>" ALT="Next"></A>
			</TD>

			<TD>
				<FORM Name="frmViewCal">
					<INPUT TYPE="HIDDEN" NAME="date" VALUE="<%=sd.getJulianDate()%>">
					<LABEL FOR="IDcriteria"><%=rb.getString("Calendar")%></LABEL>
					&nbsp;&nbsp;&nbsp;<%=CalHelper.getCriteriaDropDown(cCriteria, "frmViewCal.submit();",oUser.user_id)%>

				</FORM>
			</TD>
		</TR>
	</TABLE>

	<TABLE Class="ItemListTable">
			<%
          //
          // Iterate over the array of days.
          //
          for (int i=0; i < avDays.length; i++) {
            if (avDays[i].size()==0) {
                if (SHOW_EMPTY_DAYS) {
                    out.println("<TR><TD>"+sd.toLongString()+" (No scheduled events found.)</TD></TR>");
                }

                }
            else {
                %>

		<TR>
			<TD>
				<BR>
				<SPAN CLASS="DayHeading"><%=sd.toLongString()%></SPAN>
			</TD>
		</TR>
			<%
                Enumeration e=avDays[i].elements();
                while (e.hasMoreElements()) {
                    ci=(calitem)e.nextElement();
                    cif.setItem(ci);
                    if (!cif.isDisplayed()) {
                        continue;
                    }
                    cTime=cif.getTimeLabel(sd,CalendarItemFormatter.FLAG_START);
                    if (cTime==null) {
                        cTime="";
                    }
            %>

		<TR>
			<TD>
				<%  /*
                    cal item properties are:

                    public int cal_item_id;
                    public int calendar_id;
                    public int item_type_id;

                    public int owner;
                    public int approved;
                    public SaneDate starting_date;
                    public SaneDate ending_date;
                    public String starting_time;
                    public String ending_time;
                    public int rec_type;
                    public String description;
                    public String contact_name;
                    public String contact_info;
                    public String add_info_url;
                    public Timestamp last_update;
                    public String long_description;
                    public String owner_name;       // Virtual Field from View

                    */
                    %>

					<%=cTime%>&nbsp;<A TITLE="<%=cif.getLinkTitle(sd,new StringBuffer()).toString()%>" Class="ItemLink" HREF="JavaScript:popItem(<%=ci.cal_item_id%>,<%=sd.getJulianDate()%>)"><%=cif.getEventDescription(sd,new StringBuffer()).toString()%></A>
			</TD>
		</TR>
			<%
                }
            }
            sd.add(1);
        }
        %>

	</TABLE>
	</BODY>
</HTML>
