<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<%@ page contentType = "text/html;charset=UTF-8"%>
<%@ page import="java.util.*,java.io.*,com.MHSoftware.string.MHBuffer,com.mhsoftware.cdaily.business.*,com.mhsoftware.cdaily.support.WebApp,com.MHSoftware.dates.SaneDate" %>
<%@ page import="com.mhsoftware.cdaily.servlet.CalServlet"%>

<%
/*
	Page to view a single calendar item:

	Parameters:

		cal_item_id	-	calendar item ID to view
		style_sheet	-	Style Sheet to use.
					If a style sheet is not supplied, the default style sheet specified in the
					web.xml file is used.
		detail		-	(1 or 0) display additional detail.

*/
CalServlet cs=new CalServlet();
Locale lc=cs.getNegotiatedLocale(request);
ResourceBundle rb=cs.getResourceBundle(lc);
int iCal_Item_ID=-1;
boolean bDetail=false;
if (request.getParameter("detail")!=null) {
	bDetail=Integer.parseInt(request.getParameter("detail"))==1;
}
if (request.getParameter("cal_item_id")!=null) {
	iCal_Item_ID=Integer.parseInt(request.getParameter("cal_item_id"));
}

calitem ci=new calitem(iCal_Item_ID);

String cStyleSheet=request.getParameter("style_sheet");
if (cStyleSheet==null) {
	cStyleSheet=WebApp.getProperty("DefaultStyleSheet");
}

%>
<HTML>
	<HEAD>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<META name="generator" content="Connect Daily Web Calendar Software 4.0.3-17392">
		<META name="author" content="http://www.mhsoftware.com/connectdaily.htm">
		<META name="copyright" content="Copyright 2002-2014, MH Software, Inc. All Rights Reserved">

	<%
		if (cStyleSheet!=null) {
			 out.println("<LINK REL=stylesheet HREF=\""+cStyleSheet+"\" TYPE=\"text/css\">");
		}
	%>
		<TITLE><%=ci.description%></TITLE>
	</HEAD>
	<BODY>
		<TABLE CELLPADDING=2>
			<TR><TH ColSpan=2><%=ci.description%></TH></TR>
		<%
		if (bDetail) {
			calendar c=new calendar(ci.calendar_id);
			User oTemp=new User(ci.owner);
			%>
			<TR><TH Align=LEFT>Calendar</TH><TD><%=c.name%></TD></TR>
			<TR><TH Align=LEFT>Owner</TH><TD><%=oTemp.full_name%></TD></TR>
		<%
		}
		if (ci.starting_time!=null) {
			out.println("<TR><TH Align=Left>Time</TH><TD>"+ci.starting_time);
			if (ci.ending_time!=null) {
				out.println("&nbsp;-&nbsp;"+ci.ending_time);
			}
			out.println("</TD></TR>");
		}
		if (ci.contact_name!=null) {
			out.println("<TR><TH Align=Left VAlign=Top>Contact</TH><TD>");
			out.println(ci.contact_name);
			if (ci.contact_info!=null) {
				if (ci.contact_info.indexOf('@')>0) {
					out.println("<BR><A HREF=\"mailto:"+ci.contact_info+"\">"+ci.contact_info+"</A>");
				} else
				 out.println("<BR>"+ci.contact_info);
			}
			out.println("</TD></TR>");
		}
		if (ci.add_info_url!=null) {
			%>
			<TR>
				<TH Align=Left>
					Additional Information
				</TH>
				<TD>
					<A TARGET=_BLANK HREF="<%=ci.add_info_url%>"><%=ci.add_info_url%></A>
				</TD>
			</TR>
			<%
		}
		if (bDetail) {
			out.println("<TR><TH Align=Left VAlign=Top>Recurrence</TH><TD>"+ci.getRecurrenceDescription(lc,rb)+"</TD></TR>");
		}
		if (ci.long_description!=null) {
			MHBuffer buf=new MHBuffer(ci.long_description);
			buf.replace(""+(char)10,(char)10+"<BR>");
			out.println("<TR><TH VAlign=Top Align=Left>Description</TH><TD>"+buf.toString()+"</TD></TR>");
		}
		Vector vResources=ci.getResourcesUserCanSee(WebApp.getPublicUserID(request));

		if (vResources.size()>0) {
			calitemresource cir;
			%>
			<TR>
				<TH Align=Left VAlign=Top>
					Resources
				</TH>
				<TD>
			<%
			for (int i=0; i < vResources.size(); i++) {
				cir=(calitemresource)vResources.elementAt(i);
				%>
				<%=cir.type_description%>&nbsp;&nbsp;<%=cir.resource_name%> <%=(bDetail ? (cir.approved==1 ? "(approved)" : "(Not Approved)" ) : "")%><BR>
				<%
			}
			%>
				</TD>
			</TR>
			<%
		}
		if (bDetail) {
			Vector vExceptions=ci.getExceptions();
			if (vExceptions.size() > 0) {
				%>
				<TR>
					<TH Align=Left VAlign=TOP>
						<%=(ci.getType()==calitem.TYPE_SPECIFIC ? "Specific" : "Exception")%> Dates
					</TH>
					<TD>
				<%
				Enumeration e=vExceptions.elements();
				SaneDate cie;
                while (e.hasMoreElements()) {
					cie=(SaneDate)e.nextElement();
					%>
					<%=cie.toLongString()%><BR>
					<%
				}
				%>
					</TD>
				</TR>
				<%
			}
		}
		%>
		</TABLE>
	</BODY>
</HTML>
