<SCRIPT  language="vbscript" RUNAT="Server">
'
'	Connect Daily Web Calendar Software
'
'	Copyright 2007, MH Software, Inc. All Rights Reserved
'	5023 W 120th Ave #311, Broomfield CO 80020
'	+1 303 438 9585
'
'	Last Edit By: "$Author: gsexton $"
'	Last Checkin: "$Date: 2008/09/17 20:23:44 $"
'	Revision #  : "$Revision: 1.2 $"
'
'   This file acts as a simple AJAX proxy. By default, it uses
'   caching to minimize the calls to the calendar.
'
function getDomain(sURL)
   dim iPos
   sURL=lcase(sURL)
   iPos=instr(sURL,"://")
   if  iPos>0 then
       sURL=mid(sURL,iPos+3)
       sURL=mid(sURL,1,instr(sURL,"/")-1)
   end if
   iPos=instr(sURL,".")
   if iPos>0 and InStr(iPos+1,sURL,".")>0 then
       sURL=mid(sURL,iPos+1)
   end if
   getDomain=sURL
end function

sub addHeaders(oReq, oXMLReq)
   dim sRef
   oXMLReq.setRequestHeader("Accept-Language",oReq.serverVariables("HTTP_ACCEPT_LANGUAGE"))
   oXMLReq.setRequestHeader("Via","1.1 MH Software AJAX Proxy")
   sRef=oReq.ServerVariables("HTTP_REFERER")
   if not sRef is nothing then
      oXMLReq.setRequestHeader("Referer",sRef)
   end if
end sub

</SCRIPT>
<%
const CACHE_MINUTES=60

dim sURL, oXMLReq, sData, sReqDomain,sProxyDomain

sURL=request("URL")
sReqDomain=getDomain(Request.ServerVariables("HTTP_HOST"))
sProxyDomain=getDomain(sURL)
if (sReqDomain<>sProxyDomain) and (sProxyDomain<>"mhsoftware.com") then
   Response.End
end if
sData=Cache(sURL)
if sData is nothing then
   oXMLReq = CreateObject("Microsoft.XMLHTTP")
   oXMLReq.open("GET", sURL, False)
   addHeaders(Request,oXMLReq)
   oXMLReq.Send()
   sData = oXMLReq.responseText
   oXMLReq = Nothing
   if CACHE_MINUTES>0 then
      Cache.Insert(sURL, sData, nothing, _
             DateTime.Now.AddMinutes(CACHE_MINUTES), TimeSpan.Zero)
   end if
end if

Response.CacheControl="no-cache"
Response.AddHeader("Pragma","no-cache")
if InStr(sURL,".xml")>0 or InStr(sURL,".XML")>0 then
	response.contentType="text/xml"
end if
Response.CharSet="UTF-8"
Response.write(sData)
%>
