<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">

<%@ page import="java.util.*,com.MHSoftware.dates.SaneDate,com.mhsoftware.cdaily.business.User,com.mhsoftware.cdaily.business.calitem,com.mhsoftware.cdaily.support.*,com.mhsoftware.cdaily.servlet.CalServlet" %>
<%
/*

--Calendar item properties are:--

public int cal_item_id;
public int calendar_id;
public int item_type_id;

public int owner;
public int approved;
public SaneDate starting_date;
public SaneDate ending_date;
public String starting_time;
public String ending_time;
public int rec_type;
public String description;
public String contact_name;
public String contact_info;
public String add_info_url;
public Timestamp last_update;
public String long_description;
public String owner_name;		// Virtual Field from View
*/

//NOTE:  THE INCLUDE CALENDARS DEFAULT TO approved=1 (SHOW ONLY APPROVED)
//       PASS approved=0 IF NON-APPROVED EVENTS NEED TO BE SHOWN.

    User oUser=WebApp.getPublicUser(request);
    if (oUser==null) {
        return;
    }

String absolutePrefix = request.getScheme() + "://" + request.getServerName() + request.getContextPath() + "/";
//int DAYS_DISPLAY=30;    // Not used for month calendar
boolean SHOW_EMPTY_DAYS=true;
CalServlet cs=new CalServlet();
Locale lc=cs.getNegotiatedLocale(request);
ResourceBundle rb=CalServlet.getResourceBundle(lc);

SaneDate startDate=new SaneDate();	//This date will be the first day of the displayed interval
SaneDate endDate=new SaneDate();	//This date will be the last day of the displayed interval
SaneDate currentDate=new SaneDate();	//Current date w/in start/end interval (itterates)
SaneDate today = new SaneDate();	//This date will *always* be today.
SaneDate firstFullWeek;				//First day of the first full week of the month
SaneDate nextDate;
SaneDate prevDate;

boolean detail = true;		//If set true, detail descriptions are shown (default)

calitem ci;
String cCriteria, cTime;
String referrer = "";

//This page may be accessed by other pages, but includes nav links,
//so it must know what URL to link to
if (request.getParameter("referrer")!=null) {
	referrer = request.getParameter("referrer");
} else {
	referrer = "printable_month.jsp";
}

//Look to see if a date was passed as an argument.
if (request.getParameter("date")!=null) {

	//Date was passed as an argument
	startDate=new SaneDate(Integer.parseInt(request.getParameter("date")));

} else if (request.getParameter("year")!=null && request.getParameter("month")!=null) {

	//Date passed as year/month combination
	startDate = new SaneDate(
		Integer.parseInt(request.getParameter("year")),
		Integer.parseInt(request.getParameter("month")),
		1
	);

} else if (request.getParameter("offset")!=null) {

	//Date was passed as an offset (in months +/-)
	//Note:  This has not been debuged
	int offset = Integer.parseInt(request.getParameter("offset"));

	int year = today.getYear() + (offset / 12);
	int month = today.getMonth() + (offset % 12);

	startDate = new SaneDate(year, month, 1);
}

startDate.subtract(startDate.getDay()-1);	//Ensure current date is first day of month

//Check to see if detail description should be hidden. (defaults to 1 - show detail)
if (request.getParameter("detail") != null) {
	if (request.getParameter("detail").equals("0")) {
		detail = false;
	}
}

SaneDate lastDayPrevMonth = new SaneDate(startDate.getJulianDate() - 1);	//Temp

currentDate = new SaneDate(startDate.getJulianDate());
endDate = new SaneDate(startDate.getJulianDate() + (startDate.daysPerMonth() - 1));
nextDate = new SaneDate(endDate.getJulianDate() + 1);
prevDate = new SaneDate(lastDayPrevMonth.getJulianDate() - (lastDayPrevMonth.daysPerMonth() - 1));
if (startDate.getDOW() == 0) {
	firstFullWeek = new SaneDate(startDate.getJulianDate());
} else {
	firstFullWeek = new SaneDate(startDate.getJulianDate() + (8 - startDate.getDOW()));
}

lastDayPrevMonth = null;	//Clear Temp variable

//
// Call the helper method to get the item vector, and parse the options
//
Vector v=CalHelper.getItemVectorAndOptions(request,request.getLocale());
//
// Get an array of vectors, where each element in the array corresponds
// to one day. The vectors contain the calendar items that occurr on the
// specified day.
//
Vector[] avDays=CalHelper.getDayVector(startDate,endDate,v,WebApp.getTimeZone().getID(),Locale.getDefault());
//
//	Get the criteria that was parsed out by getItemVectorAndOptions()
//
cCriteria = (String)request.getAttribute("Criteria");


//Debug - view passed criteria and query
out.println("<!-- Criteria:" + cCriteria + " Query:" + request.getQueryString() + "-->");

%>

<HTML>
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="generator" content="Connect Daily Web Calendar Software 4.0.3-17392">
<LINK REL=stylesheet HREF="<%= absolutePrefix %>beloit_printable.css" type="text/css">
<TITLE>Printable Month View</TITLE>
</HEAD>
<BODY>
<script Language=Javascript TYPE="text/javascript">
function popItem(iItemID, iSpecificDate) {
window.open("<%= absolutePrefix %>ViewItem.html?detail=0&style_sheet=beloit_default.css&integral=0&dtwhen="+iSpecificDate+"&cal_item_id="+iItemID,"ViewItemWin","scrollbars=yes,resizable=yes,status=no,location=no,menubar=no,toolbar=no,width=600,height=500");
}
</script>

<TABLE width="100%">
	<TR>
		<TD colspan="2" ALIGN="LEFT" VALIGN="TOP" >
			<FORM Name=frmViewCal>
			<INPUT TYPE="HIDDEN" NAME="date" VALUE="<%= startDate.getJulianDate() %>">
			<span class="CalLabel">Calendar &nbsp;<%=CalHelper.getCriteriaDropDown(cCriteria, "frmViewCal.submit();",oUser.user_id)%></span>
			</FORM>
		</TD>
		<TD colspan="2" ALIGN="right" VALIGN="bottom" nowrap="true">
			<A class="CalDateNav" Title="Previous" HREF="<%= absolutePrefix %>printable_month.jsp?<%=cCriteria%>&date=<%= prevDate.getJulianDate() %>"><IMG SRC="<%= absolutePrefix %>images/nav-prevmonth.gif" />Previous Month</A>
			&nbsp;&nbsp;&nbsp;&nbsp;
			<A class="CalDateNav" Title="Next" HREF="<%= absolutePrefix %>printable_month.jsp?<%=cCriteria%>&date=<%= nextDate.getJulianDate() %>">Next Month<IMG SRC="<%= absolutePrefix %>images/nav-nextmonth.gif" /></A>
		</TD>
	</TR>
	<TR>
		<TD align="center">
			<A class="CalDateNav" Title="Printable First Full Week" HREF="<%= absolutePrefix %>printable_week.jsp?<%=cCriteria%>&date=<%= firstFullWeek.getJulianDate() %>&approved=1"><img src="<%= absolutePrefix %>images/icon-print.gif">Printable Week</A>
		</TD>
		<TD align="center">
			<A class="CalDateNav" Title="Goto Month Calendar" HREF="<%= absolutePrefix %>ViewCal.html?<%=cCriteria%>&date=<%= startDate.getJulianDate() %>&approved=1"><img src="<%= absolutePrefix %>images/icon-viewcal.gif">Full Month Calendar</A>
		</TD>
		<TD align="center">
			<A class="CalDateNav" Title="Goto Week Calendar" HREF="<%= absolutePrefix %>ViewWeek.html?<%=cCriteria%>&year=<%= firstFullWeek.getYear() %>&week=<%= firstFullWeek.getWeek() %>&approved=1"><img src="<%= absolutePrefix %>images/icon-viewcal.gif">Full Week Calendar</A>
		</TD>
		<TD align="center">
<% if (detail) { %>
			<A class="CalDateNav" Title="Hide Details" HREF="<%= absolutePrefix %>printable_month.jsp?<%=cCriteria%>&date=<%= startDate.getJulianDate() %>&detail=0">[Hide Details]</A>
<% } else { %>
			<A class="CalDateNav" Title="Show Details" HREF="<%= absolutePrefix %>printable_month.jsp?<%=cCriteria%>&date=<%= startDate.getJulianDate() %>&detail=1">[Show Details]</A>
<% } %>
		</TD>
	</TR>
</TABLE>
<hr size="1" color="#FF9900" width="100%">
<p class="CalTitle"><%= startDate.toLongString() %> - <%= endDate.toLongString() %></p>
<hr size="1" color="#FF9900" width="100%">
<TABLE>
<%
for (int i=0; i < avDays.length; i++) {
	if (avDays[i].size()==0) {
		if (SHOW_EMPTY_DAYS) {
%>
<TR>
<TD colspan="3"><span class="CalDayLabel"><%=currentDate.toLongString()%></span><span class="CalItemInfo">&nbsp;(No scheduled events found.)</span></TD>
</TR>
<%
		}

	} else {
%>
<TR>
<TD colspan="3"><p class="CalDayLabel"><%=currentDate.toLongString()%></p></TD>
</TR>
<%
		Enumeration e=avDays[i].elements();
		while (e.hasMoreElements()) {
			ci=(calitem)e.nextElement();
			cTime=(ci.starting_time==null ? "All Day" : ci.starting_time);
%>
<TR>
<TD VALIGN="TOP"><IMG Border=0 SRC="<%= absolutePrefix %>images/nav-nextmonth.gif" ALT="Item" /></TD>
<TD VALIGN="TOP" nowrap="true"><p class="CalTimeLabel"><%=cTime%></p></TD>
<TD VALIGN="TOP"><a class="CalItemLink" HREF="JavaScript:popItem(<%=ci.cal_item_id%>,<%=currentDate.getJulianDate()%>)"><%=ci.description%></a></TD>
</TR>
<%
			if (detail && ci.long_description != null && (!ci.long_description.equals(""))) {
%>
<TR>
<TD/>
<TD/>
<TD VALIGN="TOP"><p class="CalItemInfo"><%=ci.long_description%></p></TD>
</TR>
<%
			}
			String infoURL = ci.add_info_url;
			if (infoURL != null && ! infoURL.equals("")) {
				if (! infoURL.startsWith("http://")) infoURL = "http://" + infoURL;
%>
<TR>
<TD/>
<TD/>
<TD><p class="CalItemInfo">For more information visit:&nbsp;<a class="CalItemInfoLink" href="<%= infoURL %>" target="_blank"><%= infoURL %></a></p></TD>
</TR>
<%			}
		}
	}
	currentDate.add(1);
}
%>
</TABLE>
</BODY>
</HTML>
