<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<%@ page contentType = "text/html;charset=UTF-8"%>
<%@ page import="java.sql.SQLException,java.util.*,java.io.*,com.mhsoftware.cdaily.support.importing.*,com.MHSoftware.string.MHBuffer,com.mhsoftware.cdaily.business.*,com.mhsoftware.cdaily.support.WebApp,com.MHSoftware.dates.SaneDate" %>
<%@ page import="com.mhsoftware.cdaily.servlet.CalServlet"%>
<head>
    <title>location conversion routine.</title>
</head>
<body>
    <%
    if ("POST".equals(request.getMethod())) {
        CalServlet cs=new CalServlet();
        User u=cs.getUser(request,response);
        Vector<calitem> vItems=calitem.getForCriteria(calitem.class,"vCalItem","xml_data is not null","cal_item_id",null);
        out.println("<br>Examining "+vItems.size()+" candidate events for conversion.<br>");
        Importer imp=new ICalImporter();
        imp.setUser(u);
        for (calitem ci : vItems) {
           Properties p=ci.getXMLTabData();
           Set<Map.Entry<Object,Object>> es=p.entrySet();
           for (Map.Entry<Object,Object> me : es) {
               if ("Location".equalsIgnoreCase(me.getKey().toString())) {
                   imp.setCurrentEvent(ci);
                   try {
                       imp.setLocation(me.getValue().toString());
                       ci.update();
                       out.println("<br>Converting event: "+ci.cal_item_id+" "+ci.description);
                   } catch (SQLException se) {
                       out.println("Updating event: "+ci.cal_item_id+" - "+ci.description+" "+se.toString()+"<br>");
                   }
		   break;
               }
           }
        }
        out.println("<br>conversion complete.<br>");
    }
            %>
            
<%
  if ("GET".equals(request.getMethod())) {
      %>
      
<form method="post" action="ConvertLocations.jsp">
    Click on the submit button to convert location custom field values to locations 
    for events.
    <br>
    <br>
    <input type="submit">
</form>
<br>
<br>
The underlying data won't be changed. To undo the import follow these steps:
<ol>
    <li>From System | Configuration | Database Configuration, run these command:
        <ul>
            <li>update calitem set location_id=null</li>
            <li>delete from location</li>
        </ul>
    <li>Go to System | Configuration | Security and Select Repair Security.</li>
</ol>
<br>
If you've done it and everything looks good, run this statement against the db:
<br>
<br>
update calitem set xml_data=null


      <%
  }
%>
</body>
</html>
