<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<%@ page contentType = "text/html; charset=UTF-8"%>
<%@ page import="java.util.*,com.mhsoftware.cdaily.support.*,java.io.*,com.MHSoftware.dates.SaneDate,com.mhsoftware.cdaily.business.*,com.mhsoftware.cdaily.support.*,com.mhsoftware.cdaily.servlet.*,com.MHSoftware.servlet.*" %>
<%
/*
    Connect Daily Web Calendar Software
    
    Copyright 2008, MH Software, Inc. All Rights Reserved
    5023 W 120th Ave #311, Broomfield CO 80020
    +1 303 438 9585
    
    Last Edit By: "$Author: gsexton $"
    Last Checkin: "$Date: 2014/09/22 21:28:33 $"
    Revision #  : "$Revision: 1.10 $"
    
    This JSP page is a sample page that shows how you can create
    a completely customized display for a day, week, or event view.

    For a week view, set the DAYS_DISPLAY variable to 7. For a
    single day, set it to one day.

    If you only have a few events, you could set the DAYS_DISPLAY
    to something like 90. The output would then be a list of events 
	for the next 90 days.

*/

int DAYS_DISPLAY=WebApp.getIntProperty("RSSDefaultDaySpan",6);    // This argument will be overridden by the URL argument dayspan=
CalServlet cs=new CalServlet();
// Get our Effective User
//
User oUser=cs.getUser(request,response,true);
if (oUser==null) {
    return;
}
Locale lc=cs.getNegotiatedLocale(request);
ResourceBundle rb=CalServlet.getResourceBundle(lc);
ParameterParser pp=new ParameterParser(request,WebApp.CHARSET);
SaneDate sd=new SaneDate(TimeZone.getTimeZone(CalServlet.getDisplayTZ(request,oUser)),lc),sdEnd;
int MAX_EVENTS=pp.getIntParameter("max_events",WebApp.getIntProperty("RSSDefaultMaxCount",12));
//
//  Look to see if a date was passed as an argument.
//
if (request.getParameter("date")!=null) {
    sd=new SaneDate(Integer.parseInt(request.getParameter("date")));
} else if (request.getParameter("offset")!=null) {
        sd.add(pp.getIntParameter("offset"));
}

sd.setLocale(lc);
sdEnd=new SaneDate(sd.getJulianDate()+pp.getIntParameter("dayspan",DAYS_DISPLAY)-1);
//
// Call the helper method to get the item vector, and parse the options
//
Vector v=CalHelper.getItemVectorAndOptions(request,lc);
// Get an array of vectors, where each element in the array corresponds
// to one day. The vectors contain the calendar items that occurr on the
// specified day.
Vector[] avDays=CalHelper.getDayVector(sd,sdEnd,CalHelper.processAdditionalFilters(v,request,oUser.user_id),WebApp.getTimeZone().getID(),lc);
//
// Set up a calendar item formatter. It does some handy things.
//
CalendarItemFormatter cif=(CalendarItemFormatter)request.getAttribute("Formatter");
cif.setResourceBundle(rb);
cif.setTimeZone(WebApp.getTimeZone());
// cif.setIncludeResources(true); // true to force on, false to force off
%>
<HTML>
<HEAD>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <%=CalServlet.getGeneratorMeta()%>
	<META name="author" content="http://www.mhsoftware.com/connectdaily.htm">
	<META name="copyright" content="Copyright 2002-2014, MH Software, Inc. All Rights Reserved">
	<TITLE>Event List</TITLE>
    	<LINK REL="stylesheet" HREF="style.css" TYPE="text/css">
	<%=CalServlet.getDijitCSS()%>
	
</HEAD>
    <body>
        
    
	<%=CalServlet.getDijitScript(lc,"dijit.Dialog")%>
    <SCRIPT TYPE="text/javascript" SRC="scripts/<%=WebApp.PRODUCT_VERSION%>/popWindows.js"></SCRIPT>
	<DL Class=SimpleList>
        <%
        //
        // Iterate over the array of days.
        //
	Set sDisplayed=new HashSet();
        for (int i=0; sDisplayed.size() < MAX_EVENTS && i < avDays.length; i++) {
			if (avDays[i].size()==0) {
				sd.add(1);
				continue;
			}
            %>
            <dt><%=sd.toString()%></dt>
            <%
			Enumeration e=avDays[i].elements();
			calitem ci;
			while (e.hasMoreElements()) {
				ci=(calitem)e.nextElement();
				cif.setItem(ci);
				if (!cif.isDisplayed() || sDisplayed.contains(ci)) {
					continue;
				}
				//	sDisplayed.add(ci);
            %>
                <dd onclick="JavaScript:popItem(<%=ci.cal_item_id%>,<%=sd.getJulianDate()%>,0,<%=System.currentTimeMillis()%>)"><%=cif.getEventDescription(sd,new StringBuffer()).toString()%></dd>
			<%
            }
            sd.add(1);
        }
        %>
    </DL>
	</BODY>
</HTML>
