<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<%@ page contentType = "text/html; charset=UTF-8"%>
<%@ page import="java.util.*" %>
<%
/*
    This JSP page is a debugging page to show browser headers and server info.
*/
ServletContext sc=getServletContext();

response.setHeader("Cache-Control", "no-cache");
response.setHeader("Pragma", "no-cache");
java.net.InetAddress ia=java.net.InetAddress.getLocalHost();
%>
<HTML>
	<HEAD>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<TITLE>Debugging Information</TITLE>
        <STYLE>
            CAPTION {font-size: 16pt;}
        </STYLE>
	</HEAD>
	<BODY>
        <%if (request.getRemoteUser()!=null) {%>
        Remote User=[<%=request.getRemoteUser()%>]
        <%}%>
        <TABLE BORDER=1>
            <CAPTION>
                Server Info
            </CAPTION>
	    <TR><TH ALIGN=LEFT>Host Name</TH>
		<TD>
		<%=ia.getHostName()%> (<%=ia.toString()%>)
		</TD></TR>
            <TR><TH ALIGN=LEFT>Server Info</TH><TD><%=sc.getServerInfo()%></TD></TR>
            <TR><TH ALIGN=LEFT>API Version</TH><TD><%=sc.getMajorVersion()%>.<%=sc.getMinorVersion()%></TD></TR>
            <TR><TH ALIGN=LEFT>Context Path</TH><TD><%=sc.getRealPath("/")%></TD></TR>
        </TABLE>
         <BR><BR>
        <TABLE BORDER=1 CELLPADDING=3>
            <CAPTION>
                Browser Headers
            </CAPTION>
            <TR><TH>Name</TH><TH>Value</TH></TR>
            <%
			Enumeration e=request.getHeaderNames();
            List lstNames=new ArrayList();
            String sName;
            while (e.hasMoreElements()) {
                lstNames.add(e.nextElement());
			}
            Collections.sort(lstNames);
            Iterator itr=lstNames.iterator();

            while (itr.hasNext()) {
                sName=(String)itr.next();
				%>
            <TR><TD><%=sName%></TD><TD><%=request.getHeader(sName)%></TD></TR>
                <%
			}
			%>
         </TABLE>
         <BR><BR>
         <TABLE BORDER=1>
            <CAPTION>
               Engine Parsed Locales
            </CAPTION>
            <%
            Locale lc;
            e=request.getLocales();
            lc=request.getLocale();
			%>
            <TR><TH>Default</TH><TD><%=lc%></TD></TR>
             <TR><TH>All</TH><TD>
             <%
                while (e.hasMoreElements()) {
                    lc=(Locale)e.nextElement();
                    out.print(lc+", "+lc.getDisplayName()+"<BR>");
				}
			%>
                 </TD></TR>


         </TABLE>
         <BR><BR>
         <TABLE WIDTH="100%" BORDER=1>
            <CAPTION>
                   Java Properties
            </CAPTION>
             <TR><TH>Property</TH><TH>Value</TH></TR>
             <%
                Properties p=System.getProperties();
                lstNames=new ArrayList(p.size());
                e=p.keys();
                while (e.hasMoreElements()) {
                    lstNames.add(e.nextElement());
				}
                Collections.sort(lstNames);
                itr=lstNames.iterator();
                while (itr.hasNext()) {
                    sName=(String)itr.next();
                    out.print("<TR><TD>"+sName+"</TD><TD>"+p.getProperty(sName)+"</TD></TR>\n");
				}
				%>
         </TABLE>
	</BODY>
</HTML>
