<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<%@ page contentType = "text/html; charset=UTF-8"%>
<%@ page import="com.MHSoftware.dates.SaneDate"%>
<%@ page import="com.MHSoftware.servlet.*"%>
<%@ page import="com.MHSoftware.servlet.dojo.amd.*"%>
<%@ page import="com.mhsoftware.cdaily.business.calendar"%>
<%@ page import="com.mhsoftware.cdaily.business.calitem"%>
<%@ page import="com.mhsoftware.cdaily.business.calitem.calitemValidateException"%>
<%@ page import="com.mhsoftware.cdaily.business.calitemresource"%>
<%@ page import="com.mhsoftware.cdaily.business.caltabs"%>
<%@ page import="com.mhsoftware.cdaily.business.candidatetokens"%>
<%@ page import="com.mhsoftware.cdaily.business.resource"%>
<%@ page import="com.mhsoftware.cdaily.business.vobjectusers"%>
<%@ page import="com.mhsoftware.cdaily.business.User"%>
<%@ page import="com.mhsoftware.cdaily.servlet.CalServlet"%>
<%@ page import="com.mhsoftware.cdaily.servlet.EditItem"%>
<%@ page import="com.mhsoftware.cdaily.support.*"%>
<%@ page import="com.mhsoftware.cdaily.support.xml.*"%>
<%@ page import="com.MHSoftware.times.TimeUtils"%>
<%@ page import="java.util.*"%>
<%@ page import="javax.mail.MessagingException"%>
<%
/*
    Connect Daily Web Calendar Software

    Copyright 2002-2008, MH Software, Inc. All Rights Reserved
    5023 W 120th Ave #311, Broomfield CO 80020
    +1 303 438 9585

    Last Edit By: "$Author: gsexton $"
    Last Checkin: "$Date: 2014/11/13 19:25:54 $"
    Revision #  : "$Revision: 1.79 $"

    This page allows you to have anonymous users be able to add
    calendar events. Refer to the documentation for information on
    using this.
*/

    User oUser=WebApp.getPublicUser(request);
    if (oUser==null) {
        return;
    }
    boolean bResources=!WebApp.getBooleanProperty("DisableResources") &&
        vobjectusers.checkTokenForAnyInstance(oUser.user_id, candidatetokens.TYPE_ID_RESOURCES,candidatetokens.TOKEN_USE);

    ParameterParser pp=new ParameterParser(request,"UTF-8");
    
    calendar calTargetCal=null;
    if (pp.parameterPresent("calendar_id")) {
        calTargetCal=new calendar(pp.getIntParameter("calendar_id"));
    }
    if (calTargetCal==null || !calTargetCal.canUserUse(oUser.user_id)) {
        if (oUser.default_calendar==null) {
			calTargetCal=(calendar)calendar.getCalendarsUserHasTokenFor(oUser.user_id,candidatetokens.TOKEN_USE).elementAt(0);
		} else {
			calTargetCal=new calendar(oUser.default_calendar.intValue());
		}
	}
	calitem ci=new calitem(calTargetCal);
    CalServlet bs=new CalServlet(); // CalServlet -> BaseServlet has lots of handy-dandy methods that we can use here.
    Locale lc=bs.getNegotiatedLocale(request);
	final boolean bCustomTabs=WebApp.isModuleLicensed(WebApp.MODULE_CUSTOMFIELDS);
    if (request.getMethod().equals("POST")) {
        bs.setObjectFieldsFromRequest(request,ci,null,null,pp);
        ci.owner=oUser.user_id;
        ci.setType(calitem.TYPE_ONETIME);
		  if (bCustomTabs) {
			  calendar calForTabs=new calendar(ci.calendar_id);
			  List lstTabs=calForTabs.getTabs();
              for (int iTab=0; iTab < lstTabs.size(); iTab++) {
                  caltabs ct=(caltabs)lstTabs.get(iTab);
                  XMLInputTab xt=new XMLInputTab(ct.xml_doc);
                  xt.saveCustomFields(request,ci);
			  }
		  }
        }
    String cMessage="", cSubmit,cRecurInfo="";
    DijitDateTextBoxAMD ddtb=null;
    DijitTimeTextBoxAMD dttb=null;
    ResourceBundle rb=bs.getResourceBundle(lc);;
%>
<HTML>
<HEAD>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <META name="generator" content="Connect Daily Web Calendar Software 4.0.3-17392">
    <META name="author" content="http://www.mhsoftware.com/connectdaily.htm">
    <META name="copyright" content="Copyright 2002-2014, MH Software, Inc. All Rights Reserved">
    <LINK REL="stylesheet" HREF="userStyle.css" type="text/css">
    <META HTTP-EQUIV="Description" Content="Use this page to add items to the calendar for <%=WebApp.getProperty("CustomerName")%>">
    <TITLE>Add Calendar Event</TITLE>
    <%=CalServlet.getDijitCSS()%>
</HEAD>
    <BODY CLASS="plain">
    <%=CalServlet.getDijitDateScriptAMD(lc)%>
    <SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" SRC="scripts/<%=WebApp.PRODUCT_VERSION%>/mover.js">
    </SCRIPT>
    <SCRIPT TYPE="TEXT/JAVASCRIPT">
    function popItem(iItemID, iSpecificDate) {
        window.open("ViewItem.html?integral=0&detail=1&cal_item_id="+iItemID+
                    (iSpecificDate < 0 ? '' : '&dtwhen=' + iSpecificDate),
                    "ViewItemWin_"+(new Date().getTime()),
                    "scrollbars=yes,resizable=yes,status=no,location=no,menubar=no,toolbar=no,width=700,height=500");
    }
    
    </SCRIPT>
    <%
    if (request.getMethod().equals("POST") && "0".equals(pp.getParameter("ChangingCalendar"))) {
	if (pp.getParameter("txtNone")!=null){
        response.sendError(HttpServletResponse.SC_FORBIDDEN);
	
    return;
	}
        //
        //  The user has selected the submit item button.
        //
        bs.setObjectFieldsFromRequest(request,ci,null,null,pp);
        ci.owner=oUser.user_id;
        ci.setType(calitem.TYPE_ONETIME);
        if (pp.getParameter("recur_info")!=null) {
            cRecurInfo=pp.getParameter("recur_info");
        }
        if (cRecurInfo!=null && cRecurInfo.trim().length() > 0) {
            //
            //  Rather than hoping users can figure out how the recurrence
            //  works, we have them type it in as text, and we save it as part
            // of the description.
            //
            if (ci.long_description==null)
                ci.long_description=cRecurInfo;
            else
                ci.long_description=cRecurInfo+"\n\n"+ci.long_description;
        }
        try {
            EditItem.saveResources(request,ci,oUser);
	    EditItem.checkRequiredResourceTypes(ci,rb);
            if (ci.starting_date==null) {
	                calitemValidateException civDate=new calitemValidateException();
                    civDate.addElement("StartingDateRequired");
                    throw civDate;
			}
            if (WebApp.checkSafety(ci) && ci.validateObject(lc)) {

                String cURL=request.getRequestURL().toString();


                Hashtable htConflicts = new Hashtable();
                Vector vScratch,vResources = ci.getResources();
                calitemresource cir;

                for ( int i = vResources.size()-1; i >= 0; i-- ) {
                    cir = (calitemresource)vResources.elementAt(i);
                    vScratch = ci.getResourceConflicts(cir.resource_id);

                    if (vScratch.size() > 0) {
                        cir.setDeleteMark(true);
                        htConflicts.put(cir.resource_name, vScratch);
                    }
                }

                List lstConflicts=null;
                calendar cal=new calendar(ci.calendar_id);
                ci.style_id=cal.default_style;
                ci.privacy_opts=cal.def_privacy;
                ci.approved=(cal.isAutoApprovedFor(oUser) ? calitem.STATUS_APPROVED : calitem.STATUS_UNAPPROVED); // In case someone gets clever and modifies the form to set this on.

                if (
                    (cal.prefs & calendar.PREF_LIMITOVERLAPS)==calendar.PREF_LIMITOVERLAPS
                    ) {
                    lstConflicts=ci.getConflictsForEvent();
                }
				List lstXMLTabs=null;
				XMLInputTab xmlTab;
                if (bCustomTabs) {
					List  lstTabs=caltabs.getItemsForCalendar(ci.calendar_id);
					if (lstTabs.size()>0) {
						lstXMLTabs=new ArrayList(lstTabs.size());
						for (int iTab=0; iTab < lstTabs.size(); iTab++) {
							caltabs ct=(caltabs)lstTabs.get(iTab);
							xmlTab=new XMLInputTab(ct.xml_doc);
							xmlTab.setLocale(lc);
							xmlTab.setResourceBundle(rb);
							xmlTab.validateCustomFields(ci);
							lstXMLTabs.add(xmlTab);
						}
					}
				}

                CalendarItemFormatter cif=WebApp.getCalItemFormatter();
                cif.setUser(oUser);
                cif.setTypeAndInstance(candidatetokens.TYPE_ID_RESOURCES,-1);
                cif.setResourceBundle(rb);
                if ( htConflicts.size() > 0 ) {
                    cMessage = EditItem.formatConflictsHtml(htConflicts,rb,cif);
                } else if (lstConflicts!=null && lstConflicts.size()>0){
                    cif.setTypeAndInstance(candidatetokens.TYPE_ID_CALENDAR,cal.calendar_id);
                    cMessage+=EditItem.formatEventConflictsHtml(lstConflicts,rb,cif);
                } else {
                    cURL=cURL.substring(0,cURL.lastIndexOf("/"))+"/login.html";
					if (vResources.size()>0) {
						try {
							ci.sendResourceRequests(oUser,lc,rb,getServletContext());
						} catch (MessagingException me) {
							WebApp.log("Sending Resource Request",me);
						}

					}
                    ci.update();
		    new Logger(oUser,rb).logCreate(ci,rb.getString("PublicAddEvent"));
                    EditItem.notifyApproversAboutAddedItem(ci,cURL,lc,rb,getServletConfig().getServletContext(),oUser);
					if (lstXMLTabs!=null) {
						Iterator itr=lstXMLTabs.iterator();
						while (itr.hasNext()) {
							((XMLInputTab)itr.next()).getValidator().afterUpdate(ci);
						}
					}

                }
            }
        } catch (java.sql.SQLException se) {
            cMessage=se.toString();
            //  The save or safety check failed, reset the long_description field.
            ci.long_description=pp.getParameter("long_description");
        } catch (calitemValidateException cive) {
            StringBuffer sbResults=new StringBuffer(1024);
            sbResults.append("<BR><TABLE WIDTH=400 ALIGN=CENTER><TR><TH>").append(rb.getString("ValidationError")).append("</TH></TR><TR><TD><UL>");
            Enumeration e=cive.elements();
            while (e.hasMoreElements()) {
                sbResults.append("<LI>").append(rb.getString((String)e.nextElement()));
            }
            sbResults.append("</UL></TD></TR></TABLE>");
            cMessage=sbResults.toString();
        } catch (CustomFieldValidationException cfve) {
            Iterator itr=cfve.iterator();
			StringBuffer sbResults=new StringBuffer(1024);
			sbResults.append("<BR><TABLE WIDTH=400 ALIGN=CENTER><TR><TH>").append(rb.getString("ValidationError")).append("</TH></TR><TR><TD><UL>");
            while (itr.hasNext()) {
				sbResults.append("<LI>").append((String)itr.next());
			}
            sbResults.append("</UL></TD></TR></TABLE>");
            cMessage=sbResults.toString();
		}

        if (cMessage.length()==0) {
            %>
			<H2>Your submission has been received.</H2> <BR>
    <BR>
    Remember, your event will not be displayed until it<BR>
    has been approved by the calendar owner.<BR>
    <BR>
    To add another event, <A HREF="publicAdd.jsp">click here</A><BR>
    <BR>
    <A HREF="View.html">Click here to return to viewing calendars.</A>
    </BODY>
</HTML>
            <%
            return;
        }
    }
    %>

<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
// Override the image source for the popup date picker calendar.
imgSource="images";
</SCRIPT>
<DIV style="width: 750px; margin: 10px; border-style: solid; border-width: 2px; font-size: 8pt; padding: 4px; background-color: white;">
    <H2 STYLE="display: inline;">Public Calendar Add</H2><BR>


    <%
      if (cMessage.length()>0) {
          %>
		  <H3>Unable To Save</H3>
    <TABLE BORDER="1" WIDTH="50%">
        <TR>
            <TD>Your changes could not be saved.<BR>
                <BR>
                The error message was:</TD>
        </TR>
        <TR>
            <TD>
<%=cMessage%>
			</TD>
        </TR>
    </TABLE>
    <BR>
    <BR>
          <%
      }
      StringBuffer sbTypeDropdown=new StringBuffer(256);
      EditItem.getCalItemTypeDropDown(ci.item_type_id,sbTypeDropdown,oUser.user_id);
      StringBuffer sbCalendarDropDown=new StringBuffer(1024);
      CalHelper.getCalendarDropdown(ci.calendar_id,oUser.user_id,"calendar_id",
                                    "frmEditItem.ChangingCalendar.value='1'; frmEditItem.submit();",
                                    candidatetokens.TOKEN_USE,sbCalendarDropDown);
    %>
        		Thanks for making our calendar more complete. Please fill in the form below to 
                add your event. <BR>
    Please note that your event will not show on the calendar until approved by the 
    calendar administrator.

    <BR>
    <BR>
    <A HREF="View.html">Click here</A> to return to viewing calendars.
</DIV>

<FORM name="frmEditItem" ACTION="publicAdd.jsp" METHOD="POST"
<% if (bResources){%>
    onsubmit='return xferAllSelValues(document.frmEditItem.selSelected);'
    <%}%>
>
    <INPUT TYPE=TEXT NAME=txtNone VALUE="" CLASS="Invisible">
    <INPUT TYPE="HIDDEN" NAME="ChangingCalendar" VALUE="0">
    <TABLE BORDER="0" CELLPADDING="4">
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=idcalendar_id>
                Calendar
                </LABEL>
            </TH>
            <TD Colspan="4">
<%=sbCalendarDropDown.toString()%>
			</TD>
        </TR>
        <TR>
            <TH Align="LEFT">
                <LABEL FOR="idDescription">
                Event Title
                </LABEL>
            </TH>
            <TD COLSPAN="4">
                <INPUT Size="60" MaxLength="80" TYPE="TEXT" ID="idDescription" NAME="description" VALUE="<%=bs.htmlEncode(CalHelper.valueOrEmpty(ci.description))%>">
            </TD>
        </TR>
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=iditem_type_id>
                Event Type
                </LABEL>
            </TH>
            <TD COLSPAN="4">
<%=sbTypeDropdown%>
			</TD>
        </TR>
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=idContact_Name>
                Contact Name
                </LABEL>
            </TH>
            <TD COLSPAN="4">
                <INPUT ID=idContact_Name SIZE="60" MAXLENGTH="128" TYPE="TEXT" NAME="contact_name" VALUE="<%=bs.htmlEncode(CalHelper.valueOrEmpty(ci.contact_name))%>">
            </TD>
        </TR>
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=idContact_Info>
                Contact EMail/Phone
                </LABEL>
            </TH>
            <TD COLSPAN="4">
                <INPUT ID=idContact_Info Size="60" MAXLENGTH="128" TYPE="TEXT" NAME="contact_info" VALUE="<%=bs.htmlEncode(CalHelper.valueOrEmpty(ci.contact_info))%>">
            </TD>
        </TR>
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=idAdd_info_url>
                Addl. Info URL
                </LABEL>
            </TH>
            <TD COLSPAN="4">
                <INPUT ID=idAdd_info_url SIZE="60" MAXLENGTH="128" TYPE="TEXT" NAME="add_info_url" VALUE="<%=bs.htmlEncode(CalHelper.valueOrEmpty(ci.add_info_url))%>">
            </TD>
        </TR>
        <TR>
            <TH ALIGN="LEFT" VALIGN="TOP">
                <LABEL FOR=idLong_Description>
                Long<BR>
                Description<BR>
                <SPAN STYLE="font-size: 0.7em">
                Make sure you include information<BR>
                about the event location.
                </SPAN>
                </LABEL>
            </TH>
            <TD COLSPAN="4"><TEXTAREA ID=idLong_Description Name="long_description" COLS="60" ROWS="10"><%=bs.htmlEncode(CalHelper.valueOrEmpty(ci.long_description))%></TEXTAREA></TD>
        </TR>
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=IDstarting_date>
                Event Date 
                </LABEL>
            </TH>
            <TD>
                <%
                  ddtb=new DijitDateTextBoxAMD(ci.starting_date,lc);
					ddtb.setName("starting_date");
                    ddtb.setAttribute("required","true");
				  %>
                <%=ddtb.toString()%>
            </TD>
            <TH ALIGN="LEFT">
                <LABEL FOR=IDstarting_time>
                Start Time
                </LABEL>
            </TH>
            <TD>
            <%
			  final boolean bPicker="Picker".equals(WebApp.getProperty("TimeInputDevice","Picker"));
				if (bPicker) {
				  dttb=new DijitTimeTextBoxAMD(ci.starting_time,lc);
				  dttb.setName("starting_time");
				%>
				<%=dttb.toString()%>    
				<%
				} else {
					%>
                    <INPUT TYPE=TEXT NAME=starting_time ID=IDstarting_time SIZE=12 MAXLENGTH=12 VALUE="<%=CalHelper.valueOrEmpty(ci.starting_time)%>">
                        <%
				}
                %>
			</TD>
            <td>&nbsp;</td>
        </TR>
        <TR>
            <TH ALIGN="LEFT">
                <LABEL FOR=IDending_date>
                End Date <BR>
                <SPAN STYLE="font-size: 0.7em">
                for multi-day or recurring events
                </SPAN>
                </LABEL>
            </TH>
            <TD>
                <%
                  ddtb=new DijitDateTextBoxAMD(ci.ending_date,lc);
					ddtb.setName("ending_date");
				  %>
                <%=ddtb.toString()%>
            </TD>
            <TH ALIGN="LEFT">
                <LABEL FOR=IDending_time>
                End Time
                </LABEL>
            </TH>
            <TD>
            <%
              if (bPicker) {
				  dttb=new DijitTimeTextBoxAMD(ci.ending_time,lc);
				  dttb.setName("ending_time");
				  %>
				<%=dttb.toString()%>                
			  <% } else {
				  %>
            <INPUT TYPE=TEXT NAME=ending_time ID=IDending_time SIZE=12 MAXLENGTH=12 VALUE="<%=CalHelper.valueOrEmpty(ci.ending_time)%>">
                <%
			  }
			  %>
            </TD>
            <td>&nbsp;</td>
        </TR>
        <TR>
            <TH ALIGN="LEFT" VALIGN="TOP">
                <LABEL FOR=idRecur_Info>
                Recurrence<BR>
                Information
                <SPAN STYLE="font-size: 0.7em">
                <BR>
                <BR>
                If your event happens regularly<BR>
                please let us know about that.
                </SPAN>
                </LABEL>
            </TH>
            <TD COLSPAN="4"><TEXTAREA ID=idRecur_Info Name="recur_info" COLS="60" ROWS="4"><%=bs.htmlEncode(cRecurInfo)%></TEXTAREA></TD>
        </TR>
        <%
          // Write out the resources
          if (bResources) {
                %>

		
        <TR>
            <TH ALIGN="LEFT" VALIGN="TOP">Resources</TH>
            <TD COLSPAN="4">

                If you would like to check resource availability, <A HREF="ViewPlanner.html?resource_type_id=0" TARGET=_VG<%=System.currentTimeMillis()%>>click 
                here</A>. <BR>
                <BR>
                <%

                  StringBuffer sbRes=new StringBuffer(2048);
                  EditItem.getResourcesHTMLTable(ci,sbRes,rb,oUser.user_id);
                  %>

				  
                  <%=sbRes.toString()%>

			</TD>
        </TR>
                <%
            }
		  /*
            Custom Input Tabs.
          */
		  if (bCustomTabs) {
			  calendar calForTabs=new calendar(ci.calendar_id);
			  List lstTabs=calForTabs.getTabs();
			  if (lstTabs!=null) {
				  List lstFields=new ArrayList();
				  for (int iCust=0; iCust < lstTabs.size(); iCust++) {
					  caltabs ct=(caltabs)lstTabs.get(iCust);
					  XMLInputTab xt=new XMLInputTab(ct.xml_doc);
						xt.setResourceBundle(rb);
                      if (!xt.getPublishedFields().isEmpty()) {
						  xt.addSkipFields(lstFields);
						  out.println("<TR><TH VALIGN=TOP ALIGN=LEFT>"+xt.getCaption()+"</TH><TD COLSPAN=4>");
						  out.println(xt.renderInputFields(ci,true,new StringBuffer()).toString());
						  out.println("</TD></TR>");
						  lstFields.addAll(xt.getFieldNames(Boolean.TRUE));
					  }
				  }
			  }
		  }

        %>

		
        <TR>
            <TD COLSPAN="5" ALIGN="CENTER">
                <INPUT TYPE="SUBMIT" NAME="btnSubmit" VALUE="Submit Event">
            </TD>
        </TR>
    </TABLE>
</FORM>
<BR>
<HR>
<DIV Class="Instructions">
    <H2>Instructions</H2>
    <OL>
        <LI>
            Select the calendar you would like the item posted to from the drop down list.
        <LI>
            Select the type that you think best describes your event.
        <LI>
            Be sure to put the name (or role) of a contact, and their phone number or EMail 
            address in the contact information fields.
        <LI>
            If you have a URL to a web page with more information about the event, put that 
            URL in the <B>Addl. Info URL</B> field.
        <LI>
            In the long description field, place additional information about your event. 
            Information you may want to include would be location, attendees, or other 
            pertinent information. You can put HTML in here, but no scripting calls.
        <LI>
            If your event repeats on a regular schedule (i.e. the 2nd Thursday of each Month), 
            place that information in the Recurrence Info field, be sure to enter any 
            exceptions, or times when you won't be following that schedule as well. Also, if 
            you have a starting and ending date for the recurrence, put that in too.
    </OL>
</DIV>
<A HREF="<%=WebApp.COPYRIGHT_HOLDER_URL%>"><%=WebApp.PRODUCT_NAME+" "+WebApp.PRODUCT_VERSION+" Web Calendar, "+WebApp.COPYRIGHT_NOTICE%></A>
</BODY>
</HTML>
