import com.mhsoftware.cdaily.support.WebApp;
import java.io.*;
import java.util.*;
import com.mhsoftware.cdaily.business.User;
import java.sql.SQLException;
import com.mhsoftware.cdaily.support.security.AuthenticationProvider;

public class md5Convert {

public static void main(String[] argv) throws IOException,SQLException {
	if (argv.length!=1) {
		System.out.println("Usage: md5Convert pathToConfiguration.Properties");
		return;
		}

	/*	Load our default property bag, and move all of the data
		into WebApp, so that we can use the Middle Tiers
	*/
	InputStream fis=new FileInputStream(argv[0]);
	Properties p=WebApp.getProperties();
	p.load(fis);
	fis.close();
	// Change the Auth Provider to MD5 Sum
	p.setProperty("AuthenticationProvider","com.mhsoftware.cdaily.support.security.AuthProviderMD5");

	//
	//	Get the authentication provider, and iterate over each
	//	user, change their password to the hashed version.
	//
	AuthenticationProvider auth=WebApp.getAuthenticationProvider();
	Vector v=User.getItems();
	User u;
	for (int i=0; i < v.size(); i++) {
		u=(User)v.elementAt(i);
		if (u.password.length()<=12) {
		    System.out.println("Processing user "+u.user_name+" change "+u.password+" to "+auth.transformPassword(u.password));
		    u.password=auth.transformPassword(u.password);
		    try {
			u.update();
		    } catch (SQLException se) {
			System.out.println(se);
		    }
		}
		}

	//
	//	Write the property bag back out with the new provider
	//	definition.
	//
	OutputStream os=new FileOutputStream(argv[0]);
	p.store(os,"MD5Sum Conversion!");
	os.close();

	}

	
}
