'
'	This script will update your 2.1.3 database schema to
'	version 2.1.4. If your Access database is not in the default
'	location, you will need to change the DSN String below.
'
'
const DSN_STRING="provider=microsoft.jet.oledb.4.0;data source=c:\Program Files\MH Software\Connect Daily\jakarta-tomcat\webapps\calendar\WEB-INF\sql\access\calendar.mdb;"


dim oConn, cat

'
'	Prepare the connection and catalog object.
'
set oConn=WScript.CreateObject("ADODB.Connection")
set cat=WScript.Createobject("ADOX.Catalog")
oConn.Open DSN_STRING
set cat.activeConnection=oConn


oConn.execute "create table cd_dbversion (version_str varchar(16) not null primary key);"
oConn.execute "insert into cd_dbversion (version_str) values ('2.1.4');"

oConn.execute "alter table users add column prefs_flag integer;"
cat.Tables("users").Columns("prefs_flag").Properties("Default") = 65535
oConn.execute "update users set prefs_flag=65535 where prefs_flag is null;"

oConn.execute "alter table users add column tz_string varchar(64);"

oConn.execute "alter table calendar add column mnotify_add integer;"
cat.Tables("calendar").Columns("mnotify_add").Properties("Default") = 1
oConn.execute "update calendar set mnotify_add=1 where mnotify_add is null;"
set cat=nothing
oConn.close
set oConn=nothing

WScript.Echo "Schema is now updated to version 2.1.4"
