Function passOneElimination(ByVal iRecType As Long, ByVal iStartDate As Variant, ByVal iEndDate As Variant, ByVal iRangeStart As Long, ByVal iRangeEnd As Long) As Integer

Dim iResult As Integer
Const SPECIFIC_DATES_TYPE = 4
Const INTEGER_MIN_VALUE = -2147483648#
Const INTEGER_MAX_VALUE = 2147483647

iResult = 0
If iRecType = SPECIFIC_DATES_TYPE Then
        iResult = 1
Else
        If IsNull(iStartDate) Then
            iStartDate = INTEGER_MIN_VALUE
        End If
        If IsNull(iEndDate) Then
            iEndDate = INTEGER_MAX_VALUE
        End If
        If iStartDate < iRangeStart Then
            If iRangeStart <= iEndDate Then
                iResult = 1
            End If
        Else
            If iStartDate = iRangeStart Or iStartDate <= iRangeEnd Then
                iResult = 1
            End If
        End If
End If

passOneElimination = iResult

End Function
