--
-- To run this function from the command line you must set the
-- statement terminator to ~
--
CREATE FUNCTION passOneElimination (	
	iRecType integer,
	iStartDate integer,
	iEndDate integer,
	iRangeStart integer,
	iRangeEnd integer)
	RETURNS INTEGER
	DETERMINISTIC NO EXTERNAL ACTION
F1: BEGIN ATOMIC
	declare iResult integer DEFAULT 0;
	declare iStart integer default -2147483648;
	declare iEnd integer default 2147483647;
	IF iStartDate is not null THEN
		SET iStart=iStartDate;
	END IF;

	if iEndDate is not null THEN
		SET iEnd=iEndDate;
	END IF;

	IF iStart<iRangeStart THEN
		if iRangeStart<=iEnd THEN
			SET iResult=1;
		END IF;
	ELSE
		if ((iStart=iRangeStart) OR (iStart<=iRangeEnd)) THEN
				SET iResult=1;
		END IF;
	END IF;
	return iResult;
END
~
