@ECHO OFF
REM *****************************************************
REM *	This is a Windows CMD File to backup a postgresql
REM *   Database. You can use it from the Windows Task
REM *   Scheduler.
REM *****************************************************
REM
REM CHANGE THE PATH to point to the POSTGRESQL Dir
REM
set PG_DBPATH=C:\Program Files\PostgreSQL\9.1
REM
REM The file name will be calendar-YYYY-MM-DD-HHMMSS.bak.z
REM
set FILE_NAME=calendar-%date:~-4,4%-%date:~-10,2%-%date:~-7,2%-%time:~0,2%%time:~3,2%%time:~6,2%.bak.z
REM
REM	Set the password for the user name.
REM
set PG_PASSWORD=YOUR_DB_PASSWORD
set PATH=%PG_DBPATH%\bin;%PATH%
pg_dump -h 127.0.0.1 --username=calendar --compress=9 --no-owner --file=%FILE_NAME% calendar
