#!/bin/sh -x
#
#
#  This should be the db version you are using, and should
#  correspond to the sub-directory for your specific database.
#

DBVER=PGSQL
#
#  The directory where your servlet container library files
# are.
#

SERVER_LIB_DIR=/usr/local/jakarta-tomcat-5.5.8/common/lib
JARDIR=../../AddlJars
#JARDIR=../lib
#
#  The names of all of the jars required for your JDBC 
#  driver.
#
DRIVER_JARS=$SERVER_LIB_DIR/pg80b1jdbc3.jar
#
#  The location where mail.jar and activation.jar are
#  you probably don't have to change this.
#
MAIL_JAR=$JARDIR/mail.jar:$JARDIR/activation.jar
#
#  The class path.
#
CLASSPATH=$JARDIR/cdaily.jar:$JARDIR/MHS.jar:../classes:$DRIVER_JARS:$MAIL_JAR:$SERVER_LIB_DIR/servlet-api.jar:$JARDIR/jakarta-regexp-1.3.jar
#
#  The actual command to run.
#
java -cp $CLASSPATH com.mhsoftware.cdaily.support.db.Schema320 ../configuration.properties $DBVER/310_to_320_pre.sql $DBVER/310_to_320_post.sql
