REM The installer will insert the variables required.

echo
echo Connect Daily 3.4.x Windows Upgrader
echo Using CATALINA_HOME=%CATALINA_HOME%
echo using CATALINA_BASE=%CATALINA_BASE%
echo Using Connect Daily Lib Directory=%JAR_DIR%
echo Source Dirctory=%OLDINST%
echo Destination Dirctory=%NEWINST%

REM
REM wipe the tomcat logs
REM
erase "%CATALINA_BASE%\logs\*.*" /y
REM
REM if they were running as a root context, preserve that.
REM
if exist "%CATALINA_BASE%\conf\catalina\localhost\ROOT.xml" move "%CATALINA_BASE%\conf\catalina\localhost\calendar.xml" "%CATALINA_BASE%\conf\catalina\localhost\ROOT.xml" /y
REM
REM Copy the JDBC Jar Files
REM
java -classpath "%NEWINST%\WEB-INF\lib\cdaily.jar" com.mhsoftware.cdaily.support.update.CopyJarFiles "%OLDZIP%" "%OLDINST%\WEB-INF\lib" "%NEWINST%\WEB-INF\lib"

copy /Y "%OLDINST%\WEB-INF\style.properties" "%NEWINST%\WEB-INF"
copy /Y "%OLDINST%\WEB-INF\ldap.properties" "%NEWINST%\WEB-INF"
copy /Y "%OLDINST%\custom\en\*.*" "%NEWINST%\custom\en"
copy /Y "%OLDINST%\*.css" "%NEWINST%"

XCOPY /D /Y "%OLDINST%\*.jpg" "%NEWINST%"
XCOPY /D /Y "%OLDINST%\*.gif" "%NEWINST%"
XCOPY /D /Y "%OLDINST%\*.png" "%NEWINST%"

rem
rem  The directory where your servlet container library files
rem are.
rem
SET JAR_DIR=..\lib
rem
rem If you have additional directories containing jar files, add them
rem to the command just before the greater-than sign. The MakePath
rem script constructs a java classpath of all jars in the specified
rem directories.
rem 
cscript /NoLogo MakePath.vbs "%JAR_DIR%" "%CATALINA_HOME%\lib" "%CATALINA_BASE%\lib" > incl.bat
call incl.bat


for /F %%a in ('dir /b "%NEWINST%\*.css"') do call "%NEWINST%\css\fixcss.bat" "%NEWINST%" "%%a"

copy /y "%NEWINST%\css\Navy.css" "%NEWINST%\style.css"

