/* Load this script using conditional IE comments if you need to support IE 7 and IE 6. */

window.onload = function() {
	function addIcon(el, entity) {
		var html = el.innerHTML;
		el.innerHTML = '<span style="font-family: \'ConnectDaily\'">' + entity + '</span>' + html;
	}
	var icons = {
			'icon-home' : '&#xe000;',
			'icon-palette' : '&#xe001;',
			'icon-film' : '&#xe002;',
			'icon-pencil' : '&#xe003;',
			'icon-options' : '&#xe004;',
			'icon-wrench' : '&#xe005;',
			'icon-wand' : '&#xe006;',
			'icon-copy' : '&#xe007;',
			'icon-alarm' : '&#xe008;',
			'icon-print' : '&#xe009;',
			'icon-key' : '&#xe00a;',
			'icon-search' : '&#xe00b;',
			'icon-delete' : '&#xe00c;',
			'icon-next' : '&#xe00d;',
			'icon-previous' : '&#xe00e;',
			'icon-rss' : '&#xe010;',
			'icon-twitter' : '&#xe011;',
			'icon-facebook' : '&#xe012;',
			'icon-close' : '&#xe013;',
			'icon-day' : '&#xe014;',
			'icon-calendar' : '&#xe015;',
			'icon-location' : '&#xe016;',
			'icon-folder-upload' : '&#xe017;',
			'icon-folder' : '&#xe018;',
			'icon-folder-open' : '&#xe019;',
			'icon-exit' : '&#xe01a;',
			'icon-enter' : '&#xe01b;',
			'icon-plus' : '&#xe01c;',
			'icon-minus' : '&#xe01d;',
			'icon-checkbox' : '&#xe01f;',
			'icon-lock' : '&#xe020;',
			'icon-link' : '&#xe021;',
			'icon-save' : '&#xe022;',
			'icon-mobile' : '&#xe023;',
			'icon-envelop' : '&#xe024;',
			'icon-question' : '&#xe025;',
			'icon-arrow-down' : '&#xe026;',
			'icon-list' : '&#xe027;',
			'icon-globe' : '&#xe02a;',
			'icon-clipboard' : '&#xe02b;',
			'icon-users' : '&#xe02f;',
			'icon-arrow-right' : '&#xe02c;',
			'icon-arrow-left' : '&#xe02d;',
			'icon-backward' : '&#xe02e;',
			'icon-forward' : '&#xe030;',
			'icon-grid' : '&#xe032;',
			'icon-execute' : '&#xe031;',
			'icon-file-plus' : '&#xe033;',
			'icon-browser' : '&#xe029;',
			'icon-menu' : '&#xe034;',
			'icon-plannerview' : '&#xe028;',
			'icon-newspaper' : '&#xe00f;',
			'icon-icalendarmobile' : '&#xe01e;'
		},
		els = document.getElementsByTagName('*'),
		i, attr, c, el;
	for (i = 0; ; i += 1) {
		el = els[i];
		if(!el) {
			break;
		}
		attr = el.getAttribute('data-icon');
		if (attr) {
			addIcon(el, attr);
		}
		c = el.className;
		c = c.match(/icon-[^\s'"]+/);
		if (c && icons[c[0]]) {
			addIcon(el, icons[c[0]]);
		}
	}
};