function setDropdownValue(dd,val) {
    if (dd!=null) {
            {
                for (i=0; i < dd.options.length; i++)
                {
                    o=dd.options[i];
                    if (o.value==val)
                    {
                        o.selected=true;
                        dd.selectedIndex=i;
                        break;
                    }
                }
            }
    }
}
/*
    This function does an AJAX query to the calendar and updates
    fields that are dependent upon the selected calendar.
*/
function refreshCalendarDependents(ddCalendar) {
    var xhrArgs = {
        url: "json/Approval"+new Date().getTime()+".js?request_number=1&calendar_id="+ddCalendar.options[ddCalendar.selectedIndex].value,
        handleAs: "json",
        preventCache : true,
        load: function(data) {
            var res=eval(data);
            var chkBox=document.getElementById('idApproved');
            if (chkBox!=null)
            {
                chkBox.disabled=res.approver==1 ? false : true;
                chkBox.checked=res.default_approved==1 ? true : false;
            }
            var dd=document.getElementById('iditem_type_id');
            setDropdownValue(dd,res.default_type);
            dd=document.getElementById('IDprivacy_opts');
            setDropdownValue(dd,res.default_privacy);
    	    dd=document.getElementById('idstyle_id');
    	    if (dd!=null) {
                setDropdownValue(dd,res.item_style);	
    		}
	    var rollupTab=document.getElementById('IDselAvailrollup_list');
	    if (rollupTab!=null) {
                    fChanged=false;
                    document.getElementById('IDrefresh_form').value='1';
                    document.getElementById('IDFrmEditItem').submit();
			return;
		}
            var cust=document.getElementById('IDcustom_tabs');
            if (cust!=null) 
            {
                // This code looks at the custom tabs that have been drawn,
                // and if the new calendar has a different set of custom tabs,
                // it forces a refresh.
                if (!(res.custom_tabs===cust.value))
                {
                    fChanged=false;
                    document.getElementById('IDrefresh_form').value='1';
                    document.getElementById('IDFrmEditItem').submit();
                }
            }
            //	alert('approver='+res.approver+' default_approved='+res.default_approved);
        },
        error: function(error) {
            alert('An error occurred getting the approval info. Error was:'+error);
        }
    }
//	alert(xhrArgs.url);
    dojo.xhrGet(xhrArgs);
}

