function insertAt (myField, myValue, startSel, endSel) {
	if(startSel || startSel == '0') {
		var startPos = startSel;
		var endPos = endSel;
		myField.value=myField.value.substring(0, startPos)+ myValue+ myField.value.substring(endPos, myField.value.length);
		} else {
		myField.value += myValue;
	}
}

function pasteText(msg) {
	require(['dijit/registry'],function(registry){
		var target=registry.byId('itemContextMenu').currentTarget;
		msg=msg.replace(/x22/g,'"').replace(/x27/g,"'");
		insertAt(target,msg,target.selectionStart,target.selectionEnd);
	});
}

function deletePost(postID){

	if(!confirmDelete()) {
		return;
		}


	require(["dojo/request/xhr","dojo/dom","dojo/dom-style"],function(xhr,dom,domStyle){
		xhr("SocialMediaPost.html",
			{
			"method" : "POST",
			"sync" : true,
			"preventCache": true,
			"query" : {
				"btnSubmit" : "DeletePost",
				"mediapost_id" : postID
				},
			"handleAs" : "json"
			}
			).then(function(data){
				
				if(data.result==0) {
					var node=dom.byId("IDMediaPost"+postID);
					domStyle.set(node,"display","none");
				} else {
					alert(data.message);
				}
				});
		});
}
